#include <bits/stdc++.h>

using namespace std;

#define int long long

const long long inf = 90999999999999999;
const long long mod = 1e9 + 7;

#define all(a) a.begin(), a.end()

int cnt[10][10];
vector<int> arr;

void rec(int x, int len, vector <int> a) {
    int c = 0;
    for (int i = 0; i < len; i++) {
        for (int j = i + 1; j < len; j++) {
            if (a[i] == a[j] && j - i < a[i]) {
                c++;
                break;
            }
        }
        if (c)
            break;
    }

    if (c == 0 && len != 0) {
        cnt[x][len]++;
    }

    if (len == 5) return;

    for (auto y : arr) {
        if (x == y && x != 1) continue;
        a[len] = y;
        rec(x, len + 1, a);
    }
}

void solve() {
    memset(cnt, 0, sizeof cnt);

    int n, m;
    cin >> n >> m;
    arr.assign(m, 0);

    for (int i = 0; i < m; i++)
        cin >> arr[i];

    vector <int> a(5);
    for (auto x : arr)
        rec(x, 0, a);


    vector <vector <int>> dp(9, vector <int> (n + 1));
    for (auto x : arr)
        dp[x][1] = 1;

    for (int len = 2; len <= n; len++) {
        for (auto x: arr) {
            if (x == 1) {
                for (auto y : arr) {
                    dp[x][len] = (dp[x][len] + dp[y][len - 1]) % mod;
                }
            }
            else if (len - x >= 0) {
                dp[x][len] = (dp[x][len] + dp[x][len - x] + cnt[x][x - 1]) % mod;
            }
        }
    }


    int ans = 0;
    for (auto x: arr)
        ans = (ans + dp[x][n]) % mod;
    cout << ans;
}

signed main() {
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}