#include <bits/stdc++.h>

using namespace std;

#define int long long

const long long inf = 90999999999999999;
const long long mod = 1e9 + 7;

#define all(a) a.begin(), a.end()

void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> arr(n + 2, inf);
    for (int i = 1; i <= n; i++)
        cin >> arr[i];

    bool flag = false;
    for (int i = 2; i <= n; i++)
        if (arr[i] < arr[i - 1]) flag = true;

    if (!flag) {
        while (q--) {
            int pos, x;
            cin >> pos >> x;
            int k = 0;
            if (x == 1) {
                k = 1;
            }
            else {
                if (pos == x)
                    k += pos;
                if (pos + x <= n + 1)
                    k += n + 1 - pos - x + 1;
            }
            cout << k << '\n';
        }
        return;
    }

    vector <vector <int>> p(3020, vector <int> (3020));
    for (int i = 1; i <= n; i++) {
        p[i][1]++;
        int l = i - 1, r = i + 1, k = 2;
        while (l > 0 || r < n + 1) {
            if (arr[l] < arr[r]) p[l--][k++]++;
            else p[r++][k++]++;
        }
    }
    while (q--) {
        int pos, x;
        cin >> pos >> x;
        cout << p[pos][x] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}